XIncludeHandler (Xerces2 Implementation)
Date: 2018-10-17

org.apache.xerces.xinclude

## Class XIncludeHandler

- java.lang.Object
- - org.apache.xerces.xinclude.XIncludeHandler

- All Implemented Interfaces:
    org.apache.xerces.xni.parser.XMLComponent, org.apache.xerces.xni.parser.XMLDocumentFilter, org.apache.xerces.xni.parser.XMLDocumentSource, org.apache.xerces.xni.parser.XMLDTDFilter, org.apache.xerces.xni.parser.XMLDTDSource, org.apache.xerces.xni.XMLDocumentHandler, org.apache.xerces.xni.XMLDTDHandler
  Direct Known Subclasses:
    XPointerHandler

      public class XIncludeHandler
      extends java.lang.Object
      implements org.apache.xerces.xni.parser.XMLComponent, org.apache.xerces.xni.parser.XMLDocumentFilter, org.apache.xerces.xni.parser.XMLDTDFilter

  This is a pipeline component which performs XInclude handling, according to the W3C specification for XML Inclusions.

  This component analyzes each event in the pipeline, looking for <include> elements. An <include> element is one which has a namespace of `http://www.w3.org/2001/XInclude` and a localname of `include`. When it finds an <include> element, it attempts to include the file specified in the `href` attribute of the element. If inclusion succeeds, all children of the <include> element are ignored (with the exception of checking for invalid children as outlined in the specification). If the inclusion fails, the <fallback> child of the <include> element is processed.

  See the XInclude specification for more information on how XInclude is to be used.

  This component requires the following features and properties from the component manager that uses it:

  - http://xml.org/sax/features/allow-dtd-events-after-endDTD
  - http://apache.org/xml/properties/internal/error-reporter
  - http://apache.org/xml/properties/internal/entity-resolver
  Optional property:
  - http://apache.org/xml/properties/input-buffer-size
  Furthermore, the `NamespaceContext` used in the pipeline is required to be an instance of `XIncludeNamespaceSupport`.

  Currently, this implementation has only partial support for the XInclude specification. Specifically, it is missing support for XPointer document fragments. Thus, only whole documents can be included using this component in the pipeline.

  Version:
    $Id: XIncludeHandler.java 778245 2009-05-24 22:27:32Z mrglavas $
  Author:
    Peter McCracken, IBM, Michael Glavassevich, IBM
  See Also:
    `XIncludeNamespaceSupport`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `XIncludeHandler.Notation`
    `protected static class` | `XIncludeHandler.UnparsedEntity`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static java.lang.String` | `ALLOW_UE_AND_NOTATION_EVENTS` Feature identifier: allow notation and unparsed entity events to be sent out of order.
    `protected static java.lang.String` | `BUFFER_SIZE` property identifier: buffer size.
    `static java.lang.String` | `CURRENT_BASE_URI` The identifier for the Augmentation that contains the current base URI
    `protected static java.lang.String` | `DYNAMIC_VALIDATION` Feature identifier: dynamic validation.
    `protected static java.lang.String` | `ENTITY_RESOLVER` Property identifier: entity resolver.
    `protected static java.lang.String` | `ERROR_REPORTER` Property identifier: error reporter.
    `protected java.util.Stack` | `fBaseURI`
    `protected IntStack` | `fBaseURIScope`
    `protected int` | `fBufferSize`
    `protected org.apache.xerces.xni.parser.XMLParserConfiguration` | `fChildConfig`
    `protected org.apache.xerces.xni.XMLResourceIdentifier` | `fCurrentBaseURI`
    `protected java.lang.String` | `fCurrentLanguage`
    `protected org.apache.xerces.xni.XMLLocator` | `fDocLocation`
    `protected org.apache.xerces.xni.XMLDocumentHandler` | `fDocumentHandler`
    `protected org.apache.xerces.xni.parser.XMLDocumentSource` | `fDocumentSource`
    `protected org.apache.xerces.xni.XMLDTDHandler` | `fDTDHandler`
    `protected org.apache.xerces.xni.parser.XMLDTDSource` | `fDTDSource`
    `protected org.apache.xerces.xni.parser.XMLEntityResolver` | `fEntityResolver`
    `protected XMLErrorReporter` | `fErrorReporter`
    `protected java.util.Stack` | `fExpandedSystemID`
    `protected java.lang.String` | `fHrefFromParent`
    `protected IntStack` | `fLanguageScope`
    `protected java.util.Stack` | `fLanguageStack`
    `protected java.util.Stack` | `fLiteralSystemID`
    `protected XIncludeNamespaceSupport` | `fNamespaceContext`
    `protected java.lang.String` | `fParentRelativeURI`
    `protected XIncludeHandler` | `fParentXIncludeHandler`
    `protected SecurityManager` | `fSecurityManager`
    `protected ParserConfigurationSettings` | `fSettings`
    `protected SymbolTable` | `fSymbolTable`
    `protected XIncludeTextReader` | `fXInclude10TextReader`
    `protected XIncludeTextReader` | `fXInclude11TextReader`
    `protected org.apache.xerces.xni.parser.XMLParserConfiguration` | `fXIncludeChildConfig`
    `protected XMLLocatorWrapper` | `fXIncludeLocator`
    `protected XIncludeMessageFormatter` | `fXIncludeMessageFormatter`
    `protected org.apache.xerces.xni.parser.XMLParserConfiguration` | `fXPointerChildConfig`
    `protected XPointerProcessor` | `fXPtrProcessor`
    `static java.lang.String` | `HTTP_ACCEPT`
    `static java.lang.String` | `HTTP_ACCEPT_LANGUAGE`
    `protected static java.lang.String` | `JAXP_SCHEMA_LANGUAGE` Property identifier: JAXP schema language.
    `protected static java.lang.String` | `PARSER_SETTINGS`
    `protected static java.lang.String` | `SCHEMA_VALIDATION` Feature identifier: schema validation.
    `protected static java.lang.String` | `SECURITY_MANAGER` property identifier: security manager.
    `protected static java.lang.String` | `SYMBOL_TABLE` Property identifier: symbol table.
    `protected static java.lang.String` | `VALIDATION` Feature identifier: validation.
    `static java.lang.String` | `XINCLUDE_ATTR_ACCEPT`
    `static java.lang.String` | `XINCLUDE_ATTR_ACCEPT_LANGUAGE`
    `static java.lang.String` | `XINCLUDE_ATTR_ENCODING`
    `static java.lang.String` | `XINCLUDE_ATTR_HREF`
    `static java.lang.String` | `XINCLUDE_ATTR_PARSE`
    `static java.lang.String` | `XINCLUDE_DEFAULT_CONFIGURATION`
    `static java.lang.String` | `XINCLUDE_FALLBACK`
    `protected static java.lang.String` | `XINCLUDE_FIXUP_BASE_URIS` Feature identifier: fixup base URIs.
    `protected static java.lang.String` | `XINCLUDE_FIXUP_LANGUAGE` Feature identifier: fixup language.
    `static java.lang.String` | `XINCLUDE_INCLUDE`
    `static java.lang.String` | `XINCLUDE_INCLUDED`
    `static java.lang.String` | `XINCLUDE_NS_URI`
    `static java.lang.String` | `XINCLUDE_PARSE_TEXT`
    `static java.lang.String` | `XINCLUDE_PARSE_XML`
    `static java.lang.String` | `XPOINTER`

    - ### Fields inherited from interface org.apache.xerces.xni.XMLDTDHandler

      `CONDITIONAL_IGNORE, CONDITIONAL_INCLUDE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `XIncludeHandler()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `addNotation(java.lang.String name, org.apache.xerces.xni.XMLResourceIdentifier identifier, org.apache.xerces.xni.Augmentations augmentations)` Caches a notation.
    `protected void` | `addUnparsedEntity(java.lang.String name, org.apache.xerces.xni.XMLResourceIdentifier identifier, java.lang.String notation, org.apache.xerces.xni.Augmentations augmentations)` Caches an unparsed entity.
    `void` | `attributeDecl(java.lang.String elementName, java.lang.String attributeName, java.lang.String type, java.lang.String[] enumeration, java.lang.String defaultType, org.apache.xerces.xni.XMLString defaultValue, org.apache.xerces.xni.XMLString nonNormalizedDefaultValue, org.apache.xerces.xni.Augmentations augmentations)` An attribute declaration.
    `void` | `characters(org.apache.xerces.xni.XMLString text, org.apache.xerces.xni.Augmentations augs)` Character content.
    `protected void` | `checkAndSendNotation(XIncludeHandler.Notation not)` The purpose of this method is to check if a Notation conflicts with a previously declared notation in the current pipeline stack.
    `protected void` | `checkAndSendUnparsedEntity(XIncludeHandler.UnparsedEntity ent)` The purpose of this method is to check if an UnparsedEntity conflicts with a previously declared entity in the current pipeline stack.
    `protected void` | `checkNotation(java.lang.String notName)` Checks if a Notation with the given name was declared in the DTD of the document for the current pipeline.
    `protected void` | `checkUnparsedEntity(java.lang.String entName)` Checks if an UnparsedEntity with the given name was declared in the DTD of the document for the current pipeline.
    `void` | `comment(org.apache.xerces.xni.XMLString text, org.apache.xerces.xni.Augmentations augs)` A comment.
    `protected void` | `copyFeatures(org.apache.xerces.xni.parser.XMLComponentManager from, ParserConfigurationSettings to)`
    `protected void` | `copyFeatures(org.apache.xerces.xni.parser.XMLComponentManager from, org.apache.xerces.xni.parser.XMLParserConfiguration to)`
    `void` | `doctypeDecl(java.lang.String rootElement, java.lang.String publicId, java.lang.String systemId, org.apache.xerces.xni.Augmentations augs)` Notifies of the presence of the DOCTYPE line in the document.
    `void` | `elementDecl(java.lang.String name, java.lang.String contentModel, org.apache.xerces.xni.Augmentations augmentations)` An element declaration.
    `void` | `emptyElement(org.apache.xerces.xni.QName element, org.apache.xerces.xni.XMLAttributes attributes, org.apache.xerces.xni.Augmentations augs)` An empty element.
    `void` | `endAttlist(org.apache.xerces.xni.Augmentations augmentations)` The end of an attribute list.
    `void` | `endCDATA(org.apache.xerces.xni.Augmentations augs)` The end of a CDATA section.
    `void` | `endConditional(org.apache.xerces.xni.Augmentations augmentations)` The end of a conditional section.
    `void` | `endDocument(org.apache.xerces.xni.Augmentations augs)` The end of the document.
    `void` | `endDTD(org.apache.xerces.xni.Augmentations augmentations)` The end of the DTD.
    `void` | `endElement(org.apache.xerces.xni.QName element, org.apache.xerces.xni.Augmentations augs)` The end of an element.
    `void` | `endExternalSubset(org.apache.xerces.xni.Augmentations augmentations)` The end of the DTD external subset.
    `void` | `endGeneralEntity(java.lang.String name, org.apache.xerces.xni.Augmentations augs)` This method notifies the end of a general entity.
    `void` | `endParameterEntity(java.lang.String name, org.apache.xerces.xni.Augmentations augmentations)` This method notifies the end of a parameter entity.
    `void` | `externalEntityDecl(java.lang.String name, org.apache.xerces.xni.XMLResourceIdentifier identifier, org.apache.xerces.xni.Augmentations augmentations)` An external entity declaration.
    `java.lang.String` | `getBaseURI(int depth)` Gets the base URI that was in use at that depth
    `org.apache.xerces.xni.XMLDocumentHandler` | `getDocumentHandler()` Returns the document handler
    `org.apache.xerces.xni.parser.XMLDocumentSource` | `getDocumentSource()` Returns the document source.
    `org.apache.xerces.xni.XMLDTDHandler` | `getDTDHandler()` Returns the DTD handler.
    `org.apache.xerces.xni.parser.XMLDTDSource` | `getDTDSource()`
    `java.lang.Boolean` | `getFeatureDefault(java.lang.String featureId)` Returns the default state for a feature, or null if this component does not want to report a default value for this feature.
    `java.lang.String` | `getLanguage(int depth)` Gets the language that was in use at that depth.
    `java.lang.Object` | `getPropertyDefault(java.lang.String propertyId)` Returns the default state for a property, or null if this component does not want to report a default value for this property.
    `java.lang.String[]` | `getRecognizedFeatures()` Returns a list of feature identifiers that are recognized by this component.
    `java.lang.String[]` | `getRecognizedProperties()` Returns a list of property identifiers that are recognized by this component.
    `protected java.lang.String` | `getRelativeBaseURI()` Returns a URI, relative to the include parent's base URI, of the current [base URI].
    `java.lang.String` | `getRelativeURI(int depth)` Returns a relative URI, which when resolved against the base URI at the specified depth, will create the current base URI.
    `protected boolean` | `getSawFallback(int depth)` Returns whether an <fallback> was encountered at the specified depth, as an ancestor of the current element, or as a sibling of an ancestor of the current element.
    `protected boolean` | `getSawInclude(int depth)` Return whether an <include> was encountered at the specified depth, as an ancestor of the current item.
    `protected int` | `getState()`
    `protected int` | `getState(int depth)`
    `protected void` | `handleFallbackElement()`
    `protected boolean` | `handleIncludeElement(org.apache.xerces.xni.XMLAttributes attributes)`
    `protected boolean` | `hasXIncludeNamespace(org.apache.xerces.xni.QName element)` Returns true if the element has the namespace "http://www.w3.org/2001/XInclude"
    `void` | `ignorableWhitespace(org.apache.xerces.xni.XMLString text, org.apache.xerces.xni.Augmentations augs)` Ignorable whitespace.
    `void` | `ignoredCharacters(org.apache.xerces.xni.XMLString text, org.apache.xerces.xni.Augmentations augmentations)` Characters within an IGNORE conditional section.
    `void` | `internalEntityDecl(java.lang.String name, org.apache.xerces.xni.XMLString text, org.apache.xerces.xni.XMLString nonNormalizedText, org.apache.xerces.xni.Augmentations augmentations)` An internal entity declaration.
    `protected boolean` | `isFallbackElement(org.apache.xerces.xni.QName element)` Checks if the element is an <fallback> element.
    `protected boolean` | `isIncludeElement(org.apache.xerces.xni.QName element)` Checks if the element is an <include> element.
    `protected boolean` | `isRootDocument()`
    `protected boolean` | `isTopLevelIncludedItem()` Returns true if the current element is a top level included item.
    `protected boolean` | `isTopLevelIncludedItemViaFallback()`
    `protected boolean` | `isTopLevelIncludedItemViaInclude()`
    `protected org.apache.xerces.xni.Augmentations` | `modifyAugmentations(org.apache.xerces.xni.Augmentations augs)` Modify the augmentations.
    `protected org.apache.xerces.xni.Augmentations` | `modifyAugmentations(org.apache.xerces.xni.Augmentations augs, boolean force)` Modify the augmentations.
    `void` | `notationDecl(java.lang.String name, org.apache.xerces.xni.XMLResourceIdentifier identifier, org.apache.xerces.xni.Augmentations augmentations)` A notation declaration
    `protected org.apache.xerces.xni.XMLAttributes` | `processAttributes(org.apache.xerces.xni.XMLAttributes attributes)` Processes the XMLAttributes object of startElement() calls.
    `void` | `processingInstruction(java.lang.String target, org.apache.xerces.xni.XMLString data, org.apache.xerces.xni.Augmentations augs)` A processing instruction.
    `protected void` | `processXMLBaseAttributes(org.apache.xerces.xni.XMLAttributes attributes)` Search for a xml:base attribute, and if one is found, put the new base URI into effect.
    `protected void` | `processXMLLangAttributes(org.apache.xerces.xni.XMLAttributes attributes)` Search for a xml:lang attribute, and if one is found, put the new [language] into effect.
    `protected void` | `reportFatalError(java.lang.String key)`
    `protected void` | `reportFatalError(java.lang.String key, java.lang.Object[] args)`
    `protected void` | `reportFatalError(java.lang.String key, java.lang.Object[] args, java.lang.Exception exception)`
    `protected void` | `reportResourceError(java.lang.String key)`
    `protected void` | `reportResourceError(java.lang.String key, java.lang.Object[] args)`
    `protected void` | `reportResourceError(java.lang.String key, java.lang.Object[] args, java.lang.Exception exception)`
    `void` | `reset(org.apache.xerces.xni.parser.XMLComponentManager componentManager)` Resets the component.
    `protected void` | `restoreBaseURI()` Discards the URIs at the top of the stack, and restores the ones beneath it.
    `java.lang.String` | `restoreLanguage()` Discards the language at the top of the stack, and returns the one beneath it.
    `protected boolean` | `sameBaseURIAsIncludeParent()` Returns true if the current [base URI] is the same as the [base URI] that was in effect on the include parent.
    `protected boolean` | `sameLanguageAsIncludeParent()` Returns true if the current [language] is equivalent to the [language] that was in effect on the include parent, taking case-insensitivity into account as per [RFC 3066].
    `protected void` | `saveBaseURI()` Saves the current base URI to the top of the stack.
    `protected void` | `saveLanguage(java.lang.String language)` Saves the given language on the top of the stack.
    `protected boolean` | `searchForRecursiveIncludes(java.lang.String includedSysId)` Checks if the file indicated by the given system id has already been included in the current stack.
    `void` | `setDocumentHandler(org.apache.xerces.xni.XMLDocumentHandler handler)` Sets the document handler.
    `void` | `setDocumentSource(org.apache.xerces.xni.parser.XMLDocumentSource source)` Sets the document source.
    `void` | `setDTDHandler(org.apache.xerces.xni.XMLDTDHandler handler)` Sets the DTD handler.
    `void` | `setDTDSource(org.apache.xerces.xni.parser.XMLDTDSource source)`
    `void` | `setFeature(java.lang.String featureId, boolean state)` Sets the state of a feature.
    `protected void` | `setHref(java.lang.String href)`
    `protected void` | `setParent(XIncludeHandler parent)` Set the parent of this XIncludeHandler in the tree
    `void` | `setProperty(java.lang.String propertyId, java.lang.Object value)` Sets the value of a property.
    `protected void` | `setSawFallback(int depth, boolean val)` Records that an <fallback> was encountered at the specified depth, as an ancestor of the current element, or as a sibling of an ancestor of the current element.
    `protected void` | `setSawInclude(int depth, boolean val)` Records that an <include> was encountered at the specified depth, as an ancestor of the current item.
    `protected void` | `setState(int state)`
    `protected void` | `setupCurrentBaseURI(org.apache.xerces.xni.XMLLocator locator)`
    `protected void` | `setXIncludeLocator(XMLLocatorWrapper locator)`
    `void` | `startAttlist(java.lang.String elementName, org.apache.xerces.xni.Augmentations augmentations)` The start of an attribute list.
    `void` | `startCDATA(org.apache.xerces.xni.Augmentations augs)` The start of a CDATA section.
    `void` | `startConditional(short type, org.apache.xerces.xni.Augmentations augmentations)` The start of a conditional section.
    `void` | `startDocument(org.apache.xerces.xni.XMLLocator locator, java.lang.String encoding, org.apache.xerces.xni.NamespaceContext namespaceContext, org.apache.xerces.xni.Augmentations augs)` Event sent at the start of the document.
    `void` | `startDTD(org.apache.xerces.xni.XMLLocator locator, org.apache.xerces.xni.Augmentations augmentations)` The start of the DTD.
    `void` | `startElement(org.apache.xerces.xni.QName element, org.apache.xerces.xni.XMLAttributes attributes, org.apache.xerces.xni.Augmentations augs)` The start of an element.
    `void` | `startExternalSubset(org.apache.xerces.xni.XMLResourceIdentifier identifier, org.apache.xerces.xni.Augmentations augmentations)` The start of the DTD external subset.
    `void` | `startGeneralEntity(java.lang.String name, org.apache.xerces.xni.XMLResourceIdentifier resId, java.lang.String encoding, org.apache.xerces.xni.Augmentations augs)` This method notifies the start of a general entity.
    `void` | `startParameterEntity(java.lang.String name, org.apache.xerces.xni.XMLResourceIdentifier identifier, java.lang.String encoding, org.apache.xerces.xni.Augmentations augmentations)` This method notifies of the start of a parameter entity.
    `void` | `textDecl(java.lang.String version, java.lang.String encoding, org.apache.xerces.xni.Augmentations augs)` Notifies of the presence of a TextDecl line in an entity.
    `void` | `unparsedEntityDecl(java.lang.String name, org.apache.xerces.xni.XMLResourceIdentifier identifier, java.lang.String notation, org.apache.xerces.xni.Augmentations augmentations)` An unparsed entity declaration.
    `void` | `xmlDecl(java.lang.String version, java.lang.String encoding, java.lang.String standalone, org.apache.xerces.xni.Augmentations augs)` Notifies of the presence of an XMLDecl line in the document.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### XINCLUDE_DEFAULT_CONFIGURATION

          public static final java.lang.String XINCLUDE_DEFAULT_CONFIGURATION

      See Also:
        Constant Field Values

    - #### HTTP_ACCEPT

          public static final java.lang.String HTTP_ACCEPT

      See Also:
        Constant Field Values

    - #### HTTP_ACCEPT_LANGUAGE

          public static final java.lang.String HTTP_ACCEPT_LANGUAGE

      See Also:
        Constant Field Values

    - #### XPOINTER

          public static final java.lang.String XPOINTER

      See Also:
        Constant Field Values

    - #### XINCLUDE_NS_URI

          public static final java.lang.String XINCLUDE_NS_URI

    - #### XINCLUDE_INCLUDE

          public static final java.lang.String XINCLUDE_INCLUDE

    - #### XINCLUDE_FALLBACK

          public static final java.lang.String XINCLUDE_FALLBACK

    - #### XINCLUDE_PARSE_XML

          public static final java.lang.String XINCLUDE_PARSE_XML

    - #### XINCLUDE_PARSE_TEXT

          public static final java.lang.String XINCLUDE_PARSE_TEXT

    - #### XINCLUDE_ATTR_HREF

          public static final java.lang.String XINCLUDE_ATTR_HREF

    - #### XINCLUDE_ATTR_PARSE

          public static final java.lang.String XINCLUDE_ATTR_PARSE

    - #### XINCLUDE_ATTR_ENCODING

          public static final java.lang.String XINCLUDE_ATTR_ENCODING

    - #### XINCLUDE_ATTR_ACCEPT

          public static final java.lang.String XINCLUDE_ATTR_ACCEPT

    - #### XINCLUDE_ATTR_ACCEPT_LANGUAGE

          public static final java.lang.String XINCLUDE_ATTR_ACCEPT_LANGUAGE

    - #### XINCLUDE_INCLUDED

          public static final java.lang.String XINCLUDE_INCLUDED

    - #### CURRENT_BASE_URI

          public static final java.lang.String CURRENT_BASE_URI

      The identifier for the Augmentation that contains the current base URI
      See Also:
        Constant Field Values

    - #### VALIDATION

          protected static final java.lang.String VALIDATION

      Feature identifier: validation.
      See Also:
        Constant Field Values

    - #### SCHEMA_VALIDATION

          protected static final java.lang.String SCHEMA_VALIDATION

      Feature identifier: schema validation.
      See Also:
        Constant Field Values

    - #### DYNAMIC_VALIDATION

          protected static final java.lang.String DYNAMIC_VALIDATION

      Feature identifier: dynamic validation.
      See Also:
        Constant Field Values

    - #### ALLOW_UE_AND_NOTATION_EVENTS

          protected static final java.lang.String ALLOW_UE_AND_NOTATION_EVENTS

      Feature identifier: allow notation and unparsed entity events to be sent out of order.
      See Also:
        Constant Field Values

    - #### XINCLUDE_FIXUP_BASE_URIS

          protected static final java.lang.String XINCLUDE_FIXUP_BASE_URIS

      Feature identifier: fixup base URIs.
      See Also:
        Constant Field Values

    - #### XINCLUDE_FIXUP_LANGUAGE

          protected static final java.lang.String XINCLUDE_FIXUP_LANGUAGE

      Feature identifier: fixup language.
      See Also:
        Constant Field Values

    - #### JAXP_SCHEMA_LANGUAGE

          protected static final java.lang.String JAXP_SCHEMA_LANGUAGE

      Property identifier: JAXP schema language.
      See Also:
        Constant Field Values

    - #### SYMBOL_TABLE

          protected static final java.lang.String SYMBOL_TABLE

      Property identifier: symbol table.
      See Also:
        Constant Field Values

    - #### ERROR_REPORTER

          protected static final java.lang.String ERROR_REPORTER

      Property identifier: error reporter.
      See Also:
        Constant Field Values

    - #### ENTITY_RESOLVER

          protected static final java.lang.String ENTITY_RESOLVER

      Property identifier: entity resolver.
      See Also:
        Constant Field Values

    - #### SECURITY_MANAGER

          protected static final java.lang.String SECURITY_MANAGER

      property identifier: security manager.
      See Also:
        Constant Field Values

    - #### BUFFER_SIZE

          protected static final java.lang.String BUFFER_SIZE

      property identifier: buffer size.
      See Also:
        Constant Field Values

    - #### PARSER_SETTINGS

          protected static final java.lang.String PARSER_SETTINGS

      See Also:
        Constant Field Values

    - #### fDocumentHandler

          protected org.apache.xerces.xni.XMLDocumentHandler fDocumentHandler

    - #### fDocumentSource

          protected org.apache.xerces.xni.parser.XMLDocumentSource fDocumentSource

    - #### fDTDHandler

          protected org.apache.xerces.xni.XMLDTDHandler fDTDHandler

    - #### fDTDSource

          protected org.apache.xerces.xni.parser.XMLDTDSource fDTDSource

    - #### fParentXIncludeHandler

          protected XIncludeHandler fParentXIncludeHandler

    - #### fBufferSize

          protected int fBufferSize

    - #### fParentRelativeURI

          protected java.lang.String fParentRelativeURI

    - #### fChildConfig

          protected org.apache.xerces.xni.parser.XMLParserConfiguration fChildConfig

    - #### fXIncludeChildConfig

          protected org.apache.xerces.xni.parser.XMLParserConfiguration fXIncludeChildConfig

    - #### fXPointerChildConfig

          protected org.apache.xerces.xni.parser.XMLParserConfiguration fXPointerChildConfig

    - #### fXPtrProcessor

          protected XPointerProcessor fXPtrProcessor

    - #### fDocLocation

          protected org.apache.xerces.xni.XMLLocator fDocLocation

    - #### fXIncludeLocator

          protected XMLLocatorWrapper fXIncludeLocator

    - #### fXIncludeMessageFormatter

          protected XIncludeMessageFormatter fXIncludeMessageFormatter

    - #### fNamespaceContext

          protected XIncludeNamespaceSupport fNamespaceContext

    - #### fSymbolTable

          protected SymbolTable fSymbolTable

    - #### fErrorReporter

          protected XMLErrorReporter fErrorReporter

    - #### fEntityResolver

          protected org.apache.xerces.xni.parser.XMLEntityResolver fEntityResolver

    - #### fSecurityManager

          protected SecurityManager fSecurityManager

    - #### fXInclude10TextReader

          protected XIncludeTextReader fXInclude10TextReader

    - #### fXInclude11TextReader

          protected XIncludeTextReader fXInclude11TextReader

    - #### fCurrentBaseURI

          protected final org.apache.xerces.xni.XMLResourceIdentifier fCurrentBaseURI

    - #### fBaseURIScope

          protected final IntStack fBaseURIScope

    - #### fBaseURI

          protected final java.util.Stack fBaseURI

    - #### fLiteralSystemID

          protected final java.util.Stack fLiteralSystemID

    - #### fExpandedSystemID

          protected final java.util.Stack fExpandedSystemID

    - #### fLanguageScope

          protected final IntStack fLanguageScope

    - #### fLanguageStack

          protected final java.util.Stack fLanguageStack

    - #### fCurrentLanguage

          protected java.lang.String fCurrentLanguage

    - #### fHrefFromParent

          protected java.lang.String fHrefFromParent

    - #### fSettings

          protected ParserConfigurationSettings fSettings

  - ### Constructor Detail

    - #### XIncludeHandler

          public XIncludeHandler()

  - ### Method Detail

    - #### reset

          public void reset(org.apache.xerces.xni.parser.XMLComponentManager componentManager)
                     throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.parser.XMLComponent`
      Resets the component. The component can query the component manager about any features and properties that affect the operation of the component.
      Specified by:
        `reset` in interface `org.apache.xerces.xni.parser.XMLComponent`
      Parameters:
        `componentManager` - The component manager.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by component on initialization error.

    - #### getRecognizedFeatures

          public java.lang.String[] getRecognizedFeatures()

      Returns a list of feature identifiers that are recognized by this component. This method may return null if no features are recognized by this component.
      Specified by:
        `getRecognizedFeatures` in interface `org.apache.xerces.xni.parser.XMLComponent`

    - #### setFeature

          public void setFeature(java.lang.String featureId,
                                 boolean state)
                          throws org.apache.xerces.xni.parser.XMLConfigurationException

      Sets the state of a feature. This method is called by the component manager any time after reset when a feature changes state.

      Note: Components should silently ignore features that do not affect the operation of the component.

      Specified by:
        `setFeature` in interface `org.apache.xerces.xni.parser.XMLComponent`
      Parameters:
        `featureId` - The feature identifier.
        `state` - The state of the feature.
      Throws:
        `SAXNotRecognizedException` - The component should not throw this exception.
        `SAXNotSupportedException` - The component should not throw this exception.
        `org.apache.xerces.xni.parser.XMLConfigurationException` - Thrown for configuration error. In general, components should only throw this exception if it is really a critical error.

    - #### getRecognizedProperties

          public java.lang.String[] getRecognizedProperties()

      Returns a list of property identifiers that are recognized by this component. This method may return null if no properties are recognized by this component.
      Specified by:
        `getRecognizedProperties` in interface `org.apache.xerces.xni.parser.XMLComponent`

    - #### setProperty

          public void setProperty(java.lang.String propertyId,
                                  java.lang.Object value)
                           throws org.apache.xerces.xni.parser.XMLConfigurationException

      Sets the value of a property. This method is called by the component manager any time after reset when a property changes value.

      Note: Components should silently ignore properties that do not affect the operation of the component.

      Specified by:
        `setProperty` in interface `org.apache.xerces.xni.parser.XMLComponent`
      Parameters:
        `propertyId` - The property identifier.
        `value` - The value of the property.
      Throws:
        `SAXNotRecognizedException` - The component should not throw this exception.
        `SAXNotSupportedException` - The component should not throw this exception.
        `org.apache.xerces.xni.parser.XMLConfigurationException` - Thrown for configuration error. In general, components should only throw this exception if it is really a critical error.

    - #### getFeatureDefault

          public java.lang.Boolean getFeatureDefault(java.lang.String featureId)

      Returns the default state for a feature, or null if this component does not want to report a default value for this feature.
      Specified by:
        `getFeatureDefault` in interface `org.apache.xerces.xni.parser.XMLComponent`
      Parameters:
        `featureId` - The feature identifier.
      Since:
        Xerces 2.2.0

    - #### getPropertyDefault

          public java.lang.Object getPropertyDefault(java.lang.String propertyId)

      Returns the default state for a property, or null if this component does not want to report a default value for this property.
      Specified by:
        `getPropertyDefault` in interface `org.apache.xerces.xni.parser.XMLComponent`
      Parameters:
        `propertyId` - The property identifier.
      Since:
        Xerces 2.2.0

    - #### setDocumentHandler

          public void setDocumentHandler(org.apache.xerces.xni.XMLDocumentHandler handler)

      Description copied from interface: `org.apache.xerces.xni.parser.XMLDocumentSource`
      Sets the document handler.
      Specified by:
        `setDocumentHandler` in interface `org.apache.xerces.xni.parser.XMLDocumentSource`

    - #### getDocumentHandler

          public org.apache.xerces.xni.XMLDocumentHandler getDocumentHandler()

      Description copied from interface: `org.apache.xerces.xni.parser.XMLDocumentSource`
      Returns the document handler
      Specified by:
        `getDocumentHandler` in interface `org.apache.xerces.xni.parser.XMLDocumentSource`

    - #### startDocument

          public void startDocument(org.apache.xerces.xni.XMLLocator locator,
                                    java.lang.String encoding,
                                    org.apache.xerces.xni.NamespaceContext namespaceContext,
                                    org.apache.xerces.xni.Augmentations augs)
                             throws org.apache.xerces.xni.XNIException

      Event sent at the start of the document. A fatal error will occur here, if it is detected that this document has been processed before. This event is only passed on to the document handler if this is the root document.
      Specified by:
        `startDocument` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Parameters:
        `locator` - The document locator, or null if the document location cannot be reported during the parsing of this document. However, it is strongly recommended that a locator be supplied that can at least report the system identifier of the document.
        `encoding` - The auto-detected IANA encoding name of the entity stream. This value will be null in those situations where the entity encoding is not auto-detected (e.g. internal entities or a document entity that is parsed from a java.io.Reader).
        `namespaceContext` - The namespace context in effect at the start of this document. This object represents the current context. Implementors of this class are responsible for copying the namespace bindings from the the current context (and its parent contexts) if that information is important.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### xmlDecl

          public void xmlDecl(java.lang.String version,
                              java.lang.String encoding,
                              java.lang.String standalone,
                              org.apache.xerces.xni.Augmentations augs)
                       throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDocumentHandler`
      Notifies of the presence of an XMLDecl line in the document. If present, this method will be called immediately following the startDocument call.
      Specified by:
        `xmlDecl` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Parameters:
        `version` - The XML version.
        `encoding` - The IANA encoding name of the document, or null if not specified.
        `standalone` - The standalone value, or null if not specified.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### doctypeDecl

          public void doctypeDecl(java.lang.String rootElement,
                                  java.lang.String publicId,
                                  java.lang.String systemId,
                                  org.apache.xerces.xni.Augmentations augs)
                           throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDocumentHandler`
      Notifies of the presence of the DOCTYPE line in the document.
      Specified by:
        `doctypeDecl` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Parameters:
        `rootElement` - The name of the root element.
        `publicId` - The public identifier if an external DTD or null if the external DTD is specified using SYSTEM.
        `systemId` - The system identifier if an external DTD, null otherwise.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### comment

          public void comment(org.apache.xerces.xni.XMLString text,
                              org.apache.xerces.xni.Augmentations augs)
                       throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDocumentHandler`
      A comment.
      Specified by:
        `comment` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Specified by:
        `comment` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `text` - The text in the comment.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by application to signal an error.

    - #### processingInstruction

          public void processingInstruction(java.lang.String target,
                                            org.apache.xerces.xni.XMLString data,
                                            org.apache.xerces.xni.Augmentations augs)
                                     throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDocumentHandler`
      A processing instruction. Processing instructions consist of a target name and, optionally, text data. The data is only meaningful to the application.

      Typically, a processing instruction's data will contain a series of pseudo-attributes. These pseudo-attributes follow the form of element attributes but are not parsed or presented to the application as anything other than text. The application is responsible for parsing the data.

      Specified by:
        `processingInstruction` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Specified by:
        `processingInstruction` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `target` - The target.
        `data` - The data or null if none specified.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### startElement

          public void startElement(org.apache.xerces.xni.QName element,
                                   org.apache.xerces.xni.XMLAttributes attributes,
                                   org.apache.xerces.xni.Augmentations augs)
                            throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDocumentHandler`
      The start of an element.
      Specified by:
        `startElement` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Parameters:
        `element` - The name of the element.
        `attributes` - The element attributes.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### emptyElement

          public void emptyElement(org.apache.xerces.xni.QName element,
                                   org.apache.xerces.xni.XMLAttributes attributes,
                                   org.apache.xerces.xni.Augmentations augs)
                            throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDocumentHandler`
      An empty element.
      Specified by:
        `emptyElement` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Parameters:
        `element` - The name of the element.
        `attributes` - The element attributes.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### endElement

          public void endElement(org.apache.xerces.xni.QName element,
                                 org.apache.xerces.xni.Augmentations augs)
                          throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDocumentHandler`
      The end of an element.
      Specified by:
        `endElement` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Parameters:
        `element` - The name of the element.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### startGeneralEntity

          public void startGeneralEntity(java.lang.String name,
                                         org.apache.xerces.xni.XMLResourceIdentifier resId,
                                         java.lang.String encoding,
                                         org.apache.xerces.xni.Augmentations augs)
                                  throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDocumentHandler`
      This method notifies the start of a general entity.

      Note: This method is not called for entity references appearing as part of attribute values.

      Specified by:
        `startGeneralEntity` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Parameters:
        `name` - The name of the general entity.
        `resId` - The resource identifier.
        `encoding` - The auto-detected IANA encoding name of the entity stream. This value will be null in those situations where the entity encoding is not auto-detected (e.g. internal entities or a document entity that is parsed from a java.io.Reader).
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### textDecl

          public void textDecl(java.lang.String version,
                               java.lang.String encoding,
                               org.apache.xerces.xni.Augmentations augs)
                        throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDocumentHandler`
      Notifies of the presence of a TextDecl line in an entity. If present, this method will be called immediately following the startEntity call.

      Note: This method will never be called for the document entity; it is only called for external general entities referenced in document content.

      Note: This method is not called for entity references appearing as part of attribute values.

      Specified by:
        `textDecl` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Specified by:
        `textDecl` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `version` - The XML version, or null if not specified.
        `encoding` - The IANA encoding name of the entity.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### endGeneralEntity

          public void endGeneralEntity(java.lang.String name,
                                       org.apache.xerces.xni.Augmentations augs)
                                throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDocumentHandler`
      This method notifies the end of a general entity.

      Note: This method is not called for entity references appearing as part of attribute values.

      Specified by:
        `endGeneralEntity` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Parameters:
        `name` - The name of the entity.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### characters

          public void characters(org.apache.xerces.xni.XMLString text,
                                 org.apache.xerces.xni.Augmentations augs)
                          throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDocumentHandler`
      Character content.
      Specified by:
        `characters` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Parameters:
        `text` - The content.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### ignorableWhitespace

          public void ignorableWhitespace(org.apache.xerces.xni.XMLString text,
                                          org.apache.xerces.xni.Augmentations augs)
                                   throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDocumentHandler`
      Ignorable whitespace. For this method to be called, the document source must have some way of determining that the text containing only whitespace characters should be considered ignorable. For example, the validator can determine if a length of whitespace characters in the document are ignorable based on the element content model.
      Specified by:
        `ignorableWhitespace` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Parameters:
        `text` - The ignorable whitespace.
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### startCDATA

          public void startCDATA(org.apache.xerces.xni.Augmentations augs)
                          throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDocumentHandler`
      The start of a CDATA section.
      Specified by:
        `startCDATA` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Parameters:
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### endCDATA

          public void endCDATA(org.apache.xerces.xni.Augmentations augs)
                        throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDocumentHandler`
      The end of a CDATA section.
      Specified by:
        `endCDATA` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Parameters:
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### endDocument

          public void endDocument(org.apache.xerces.xni.Augmentations augs)
                           throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDocumentHandler`
      The end of the document.
      Specified by:
        `endDocument` in interface `org.apache.xerces.xni.XMLDocumentHandler`
      Parameters:
        `augs` - Additional information that may include infoset augmentations
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### setDocumentSource

          public void setDocumentSource(org.apache.xerces.xni.parser.XMLDocumentSource source)

      Description copied from interface: `org.apache.xerces.xni.XMLDocumentHandler`
      Sets the document source.
      Specified by:
        `setDocumentSource` in interface `org.apache.xerces.xni.XMLDocumentHandler`

    - #### getDocumentSource

          public org.apache.xerces.xni.parser.XMLDocumentSource getDocumentSource()

      Description copied from interface: `org.apache.xerces.xni.XMLDocumentHandler`
      Returns the document source.
      Specified by:
        `getDocumentSource` in interface `org.apache.xerces.xni.XMLDocumentHandler`

    - #### attributeDecl

          public void attributeDecl(java.lang.String elementName,
                                    java.lang.String attributeName,
                                    java.lang.String type,
                                    java.lang.String[] enumeration,
                                    java.lang.String defaultType,
                                    org.apache.xerces.xni.XMLString defaultValue,
                                    org.apache.xerces.xni.XMLString nonNormalizedDefaultValue,
                                    org.apache.xerces.xni.Augmentations augmentations)
                             throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDTDHandler`
      An attribute declaration.
      Specified by:
        `attributeDecl` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `elementName` - The name of the element that this attribute is associated with.
        `attributeName` - The name of the attribute.
        `type` - The attribute type. This value will be one of the following: "CDATA", "ENTITY", "ENTITIES", "ENUMERATION", "ID", "IDREF", "IDREFS", "NMTOKEN", "NMTOKENS", or "NOTATION".
        `enumeration` - If the type has the value "ENUMERATION" or "NOTATION", this array holds the allowed attribute values; otherwise, this array is null.
        `defaultType` - The attribute default type. This value will be one of the following: "#FIXED", "#IMPLIED", "#REQUIRED", or null.
        `defaultValue` - The attribute default value, or null if no default value is specified.
        `nonNormalizedDefaultValue` - The attribute default value with no normalization performed, or null if no default value is specified.
        `augmentations` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### elementDecl

          public void elementDecl(java.lang.String name,
                                  java.lang.String contentModel,
                                  org.apache.xerces.xni.Augmentations augmentations)
                           throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDTDHandler`
      An element declaration.
      Specified by:
        `elementDecl` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `name` - The name of the element.
        `contentModel` - The element content model.
        `augmentations` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### endAttlist

          public void endAttlist(org.apache.xerces.xni.Augmentations augmentations)
                          throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDTDHandler`
      The end of an attribute list.
      Specified by:
        `endAttlist` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `augmentations` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### endConditional

          public void endConditional(org.apache.xerces.xni.Augmentations augmentations)
                              throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDTDHandler`
      The end of a conditional section.
      Specified by:
        `endConditional` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `augmentations` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### endDTD

          public void endDTD(org.apache.xerces.xni.Augmentations augmentations)
                      throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDTDHandler`
      The end of the DTD.
      Specified by:
        `endDTD` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `augmentations` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### endExternalSubset

          public void endExternalSubset(org.apache.xerces.xni.Augmentations augmentations)
                                 throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDTDHandler`
      The end of the DTD external subset.
      Specified by:
        `endExternalSubset` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `augmentations` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### endParameterEntity

          public void endParameterEntity(java.lang.String name,
                                         org.apache.xerces.xni.Augmentations augmentations)
                                  throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDTDHandler`
      This method notifies the end of a parameter entity. Parameter entity names begin with a '%' character.
      Specified by:
        `endParameterEntity` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `name` - The name of the parameter entity.
        `augmentations` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### externalEntityDecl

          public void externalEntityDecl(java.lang.String name,
                                         org.apache.xerces.xni.XMLResourceIdentifier identifier,
                                         org.apache.xerces.xni.Augmentations augmentations)
                                  throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDTDHandler`
      An external entity declaration.
      Specified by:
        `externalEntityDecl` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `name` - The name of the entity. Parameter entity names start with '%', whereas the name of a general entity is just the entity name.
        `identifier` - An object containing all location information pertinent to this external entity.
        `augmentations` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### getDTDSource

          public org.apache.xerces.xni.parser.XMLDTDSource getDTDSource()

      Specified by:
        `getDTDSource` in interface `org.apache.xerces.xni.XMLDTDHandler`

    - #### ignoredCharacters

          public void ignoredCharacters(org.apache.xerces.xni.XMLString text,
                                        org.apache.xerces.xni.Augmentations augmentations)
                                 throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDTDHandler`
      Characters within an IGNORE conditional section.
      Specified by:
        `ignoredCharacters` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `text` - The ignored text.
        `augmentations` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### internalEntityDecl

          public void internalEntityDecl(java.lang.String name,
                                         org.apache.xerces.xni.XMLString text,
                                         org.apache.xerces.xni.XMLString nonNormalizedText,
                                         org.apache.xerces.xni.Augmentations augmentations)
                                  throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDTDHandler`
      An internal entity declaration.
      Specified by:
        `internalEntityDecl` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `name` - The name of the entity. Parameter entity names start with '%', whereas the name of a general entity is just the entity name.
        `text` - The value of the entity.
        `nonNormalizedText` - The non-normalized value of the entity. This value contains the same sequence of characters that was in the internal entity declaration, without any entity references expanded.
        `augmentations` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### notationDecl

          public void notationDecl(java.lang.String name,
                                   org.apache.xerces.xni.XMLResourceIdentifier identifier,
                                   org.apache.xerces.xni.Augmentations augmentations)
                            throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDTDHandler`
      A notation declaration
      Specified by:
        `notationDecl` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `name` - The name of the notation.
        `identifier` - An object containing all location information pertinent to this notation.
        `augmentations` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### setDTDSource

          public void setDTDSource(org.apache.xerces.xni.parser.XMLDTDSource source)

      Specified by:
        `setDTDSource` in interface `org.apache.xerces.xni.XMLDTDHandler`

    - #### startAttlist

          public void startAttlist(java.lang.String elementName,
                                   org.apache.xerces.xni.Augmentations augmentations)
                            throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDTDHandler`
      The start of an attribute list.
      Specified by:
        `startAttlist` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `elementName` - The name of the element that this attribute list is associated with.
        `augmentations` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### startConditional

          public void startConditional(short type,
                                       org.apache.xerces.xni.Augmentations augmentations)
                                throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDTDHandler`
      The start of a conditional section.
      Specified by:
        `startConditional` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `type` - The type of the conditional section. This value will either be CONDITIONAL_INCLUDE or CONDITIONAL_IGNORE.
        `augmentations` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.
      See Also:
        `XMLDTDHandler.CONDITIONAL_INCLUDE`, `XMLDTDHandler.CONDITIONAL_IGNORE`

    - #### startDTD

          public void startDTD(org.apache.xerces.xni.XMLLocator locator,
                               org.apache.xerces.xni.Augmentations augmentations)
                        throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDTDHandler`
      The start of the DTD.
      Specified by:
        `startDTD` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `locator` - The document locator, or null if the document location cannot be reported during the parsing of the document DTD. However, it is strongly recommended that a locator be supplied that can at least report the base system identifier of the DTD.
        `augmentations` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### startExternalSubset

          public void startExternalSubset(org.apache.xerces.xni.XMLResourceIdentifier identifier,
                                          org.apache.xerces.xni.Augmentations augmentations)
                                   throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDTDHandler`
      The start of the DTD external subset.
      Specified by:
        `startExternalSubset` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `identifier` - The resource identifier.
        `augmentations` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### startParameterEntity

          public void startParameterEntity(java.lang.String name,
                                           org.apache.xerces.xni.XMLResourceIdentifier identifier,
                                           java.lang.String encoding,
                                           org.apache.xerces.xni.Augmentations augmentations)
                                    throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDTDHandler`
      This method notifies of the start of a parameter entity. The parameter entity name start with a '%' character.
      Specified by:
        `startParameterEntity` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `name` - The name of the parameter entity.
        `identifier` - The resource identifier.
        `encoding` - The auto-detected IANA encoding name of the entity stream. This value will be null in those situations where the entity encoding is not auto-detected (e.g. internal parameter entities).
        `augmentations` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### unparsedEntityDecl

          public void unparsedEntityDecl(java.lang.String name,
                                         org.apache.xerces.xni.XMLResourceIdentifier identifier,
                                         java.lang.String notation,
                                         org.apache.xerces.xni.Augmentations augmentations)
                                  throws org.apache.xerces.xni.XNIException

      Description copied from interface: `org.apache.xerces.xni.XMLDTDHandler`
      An unparsed entity declaration.
      Specified by:
        `unparsedEntityDecl` in interface `org.apache.xerces.xni.XMLDTDHandler`
      Parameters:
        `name` - The name of the entity.
        `identifier` - An object containing all location information pertinent to this unparsed entity declaration.
        `notation` - The name of the notation.
        `augmentations` - Additional information that may include infoset augmentations.
      Throws:
        `org.apache.xerces.xni.XNIException` - Thrown by handler to signal an error.

    - #### getDTDHandler

          public org.apache.xerces.xni.XMLDTDHandler getDTDHandler()

      Description copied from interface: `org.apache.xerces.xni.parser.XMLDTDSource`
      Returns the DTD handler.
      Specified by:
        `getDTDHandler` in interface `org.apache.xerces.xni.parser.XMLDTDSource`

    - #### setDTDHandler

          public void setDTDHandler(org.apache.xerces.xni.XMLDTDHandler handler)

      Description copied from interface: `org.apache.xerces.xni.parser.XMLDTDSource`
      Sets the DTD handler.
      Specified by:
        `setDTDHandler` in interface `org.apache.xerces.xni.parser.XMLDTDSource`

    - #### handleFallbackElement

          protected void handleFallbackElement()

    - #### handleIncludeElement

          protected boolean handleIncludeElement(org.apache.xerces.xni.XMLAttributes attributes)
                                          throws org.apache.xerces.xni.XNIException

      Throws:
        `org.apache.xerces.xni.XNIException`

    - #### hasXIncludeNamespace

          protected boolean hasXIncludeNamespace(org.apache.xerces.xni.QName element)

      Returns true if the element has the namespace "http://www.w3.org/2001/XInclude"
      Parameters:
        `element` - the element to check
      Returns:
        true if the element has the namespace "http://www.w3.org/2001/XInclude"

    - #### isIncludeElement

          protected boolean isIncludeElement(org.apache.xerces.xni.QName element)

      Checks if the element is an <include> element. The element must have the XInclude namespace, and a local name of "include".
      Parameters:
        `element` - the element to check
      Returns:
        true if the element is an <include> element
      See Also:
        `hasXIncludeNamespace(QName)`

    - #### isFallbackElement

          protected boolean isFallbackElement(org.apache.xerces.xni.QName element)

      Checks if the element is an <fallback> element. The element must have the XInclude namespace, and a local name of "fallback".
      Parameters:
        `element` - the element to check
      Returns:
        true if the element is an <fallback; element
      See Also:
        `hasXIncludeNamespace(QName)`

    - #### sameBaseURIAsIncludeParent

          protected boolean sameBaseURIAsIncludeParent()

      Returns true if the current [base URI] is the same as the [base URI] that was in effect on the include parent. This method should only be called when the current element is a top level included element, i.e. the direct child of a fallback element, or the root elements in an included document. The "include parent" is the element which, in the result infoset, will be the direct parent of the current element.
      Returns:
        true if the [base URIs] are the same string

    - #### sameLanguageAsIncludeParent

          protected boolean sameLanguageAsIncludeParent()

      Returns true if the current [language] is equivalent to the [language] that was in effect on the include parent, taking case-insensitivity into account as per [RFC 3066]. This method should only be called when the current element is a top level included element, i.e. the direct child of a fallback element, or the root elements in an included document. The "include parent" is the element which, in the result infoset, will be the direct parent of the current element.
      Returns:
        true if the [language] properties have the same value taking case-insensitivity into account as per [RFC 3066].

    - #### setupCurrentBaseURI

          protected void setupCurrentBaseURI(org.apache.xerces.xni.XMLLocator locator)

    - #### searchForRecursiveIncludes

          protected boolean searchForRecursiveIncludes(java.lang.String includedSysId)

      Checks if the file indicated by the given system id has already been included in the current stack.
      Parameters:
        `includedSysId` - the system id to check for inclusion
      Returns:
        true if the source has already been included

    - #### isTopLevelIncludedItem

          protected boolean isTopLevelIncludedItem()

      Returns true if the current element is a top level included item. This means it's either the child of a fallback element, or the top level item in an included document
      Returns:
        true if the current element is a top level included item

    - #### isTopLevelIncludedItemViaInclude

          protected boolean isTopLevelIncludedItemViaInclude()

    - #### isTopLevelIncludedItemViaFallback

          protected boolean isTopLevelIncludedItemViaFallback()

    - #### processAttributes

          protected org.apache.xerces.xni.XMLAttributes processAttributes(org.apache.xerces.xni.XMLAttributes attributes)

      Processes the XMLAttributes object of startElement() calls. Performs the following tasks:
      - If the element is a top level included item whose [base URI] is different from the [base URI] of the include parent, then an xml:base attribute is added to specify the true [base URI]
      - For all namespace prefixes which are in-scope in an included item, but not in scope in the include parent, a xmlns:prefix attribute is added
      - For all attributes with a type of ENTITY, ENTITIES or NOTATIONS, the notations and unparsed entities are processed as described in the spec, sections 4.5.1 and 4.5.2
      Parameters:
        `attributes` -
      Returns:
        the processed XMLAttributes

    - #### getRelativeBaseURI

          protected java.lang.String getRelativeBaseURI()
                                                 throws URI.MalformedURIException

      Returns a URI, relative to the include parent's base URI, of the current [base URI]. For instance, if the current [base URI] was "dir1/dir2/file.xml" and the include parent's [base URI] was "dir/", this would return "dir2/file.xml".
      Returns:
        the relative URI
      Throws:
        `URI.MalformedURIException`

    - #### modifyAugmentations

          protected org.apache.xerces.xni.Augmentations modifyAugmentations(org.apache.xerces.xni.Augmentations augs)

      Modify the augmentations. Add an [included] infoset item, if the current element is a top level included item.
      Parameters:
        `augs` - the Augmentations to modify.
      Returns:
        the modified Augmentations

    - #### modifyAugmentations

          protected org.apache.xerces.xni.Augmentations modifyAugmentations(org.apache.xerces.xni.Augmentations augs,
                                                                            boolean force)

      Modify the augmentations. Add an [included] infoset item, if `force` is true, or if the current element is a top level included item.
      Parameters:
        `augs` - the Augmentations to modify.
        `force` - whether to force modification
      Returns:
        the modified Augmentations

    - #### getState

          protected int getState(int depth)

    - #### getState

          protected int getState()

    - #### setState

          protected void setState(int state)

    - #### setSawFallback

          protected void setSawFallback(int depth,
                                        boolean val)

      Records that an <fallback> was encountered at the specified depth, as an ancestor of the current element, or as a sibling of an ancestor of the current element.
      Parameters:
        `depth` -
        `val` -

    - #### getSawFallback

          protected boolean getSawFallback(int depth)

      Returns whether an <fallback> was encountered at the specified depth, as an ancestor of the current element, or as a sibling of an ancestor of the current element.
      Parameters:
        `depth` -

    - #### setSawInclude

          protected void setSawInclude(int depth,
                                       boolean val)

      Records that an <include> was encountered at the specified depth, as an ancestor of the current item.
      Parameters:
        `depth` -
        `val` -

    - #### getSawInclude

          protected boolean getSawInclude(int depth)

      Return whether an <include> was encountered at the specified depth, as an ancestor of the current item.
      Parameters:
        `depth` -
      Returns:
        true if an include was seen at the given depth, false otherwise

    - #### reportResourceError

          protected void reportResourceError(java.lang.String key)

    - #### reportResourceError

          protected void reportResourceError(java.lang.String key,
                                             java.lang.Object[] args)

    - #### reportResourceError

          protected void reportResourceError(java.lang.String key,
                                             java.lang.Object[] args,
                                             java.lang.Exception exception)

    - #### reportFatalError

          protected void reportFatalError(java.lang.String key)

    - #### reportFatalError

          protected void reportFatalError(java.lang.String key,
                                          java.lang.Object[] args)

    - #### reportFatalError

          protected void reportFatalError(java.lang.String key,
                                          java.lang.Object[] args,
                                          java.lang.Exception exception)

    - #### setParent

          protected void setParent(XIncludeHandler parent)

      Set the parent of this XIncludeHandler in the tree
      Parameters:
        `parent` -

    - #### setHref

          protected void setHref(java.lang.String href)

    - #### setXIncludeLocator

          protected void setXIncludeLocator(XMLLocatorWrapper locator)

    - #### isRootDocument

          protected boolean isRootDocument()

    - #### addUnparsedEntity

          protected void addUnparsedEntity(java.lang.String name,
                                           org.apache.xerces.xni.XMLResourceIdentifier identifier,
                                           java.lang.String notation,
                                           org.apache.xerces.xni.Augmentations augmentations)

      Caches an unparsed entity.
      Parameters:
        `name` - the name of the unparsed entity
        `identifier` - the location of the unparsed entity
        `augmentations` - any Augmentations that were on the original unparsed entity declaration

    - #### addNotation

          protected void addNotation(java.lang.String name,
                                     org.apache.xerces.xni.XMLResourceIdentifier identifier,
                                     org.apache.xerces.xni.Augmentations augmentations)

      Caches a notation.
      Parameters:
        `name` - the name of the notation
        `identifier` - the location of the notation
        `augmentations` - any Augmentations that were on the original notation declaration

    - #### checkUnparsedEntity

          protected void checkUnparsedEntity(java.lang.String entName)

      Checks if an UnparsedEntity with the given name was declared in the DTD of the document for the current pipeline. If so, then the notation for the UnparsedEntity is checked. If that turns out okay, then the UnparsedEntity is passed to the root pipeline to be checked for conflicts, and sent to the root DTDHandler.
      Parameters:
        `entName` - the name of the UnparsedEntity to check

    - #### checkNotation

          protected void checkNotation(java.lang.String notName)

      Checks if a Notation with the given name was declared in the DTD of the document for the current pipeline. If so, that Notation is passed to the root pipeline to be checked for conflicts, and sent to the root DTDHandler
      Parameters:
        `notName` - the name of the Notation to check

    - #### checkAndSendUnparsedEntity

          protected void checkAndSendUnparsedEntity(XIncludeHandler.UnparsedEntity ent)

      The purpose of this method is to check if an UnparsedEntity conflicts with a previously declared entity in the current pipeline stack. If there is no conflict, the UnparsedEntity is sent by the root pipeline.
      Parameters:
        `ent` - the UnparsedEntity to check for conflicts

    - #### checkAndSendNotation

          protected void checkAndSendNotation(XIncludeHandler.Notation not)

      The purpose of this method is to check if a Notation conflicts with a previously declared notation in the current pipeline stack. If there is no conflict, the Notation is sent by the root pipeline.
      Parameters:
        `not` - the Notation to check for conflicts

    - #### copyFeatures

          protected void copyFeatures(org.apache.xerces.xni.parser.XMLComponentManager from,
                                      ParserConfigurationSettings to)

    - #### copyFeatures

          protected void copyFeatures(org.apache.xerces.xni.parser.XMLComponentManager from,
                                      org.apache.xerces.xni.parser.XMLParserConfiguration to)

    - #### saveBaseURI

          protected void saveBaseURI()

      Saves the current base URI to the top of the stack.

    - #### restoreBaseURI

          protected void restoreBaseURI()

      Discards the URIs at the top of the stack, and restores the ones beneath it.

    - #### saveLanguage

          protected void saveLanguage(java.lang.String language)

      Saves the given language on the top of the stack.
      Parameters:
        `language` - the language to push onto the stack.

    - #### restoreLanguage

          public java.lang.String restoreLanguage()

      Discards the language at the top of the stack, and returns the one beneath it.

    - #### getBaseURI

          public java.lang.String getBaseURI(int depth)

      Gets the base URI that was in use at that depth
      Parameters:
        `depth` -
      Returns:
        the base URI

    - #### getLanguage

          public java.lang.String getLanguage(int depth)

      Gets the language that was in use at that depth.
      Parameters:
        `depth` -
      Returns:
        the language

    - #### getRelativeURI

          public java.lang.String getRelativeURI(int depth)
                                          throws URI.MalformedURIException

      Returns a relative URI, which when resolved against the base URI at the specified depth, will create the current base URI. This is accomplished by merged the literal system IDs.
      Parameters:
        `depth` - the depth at which to start creating the relative URI
      Returns:
        a relative URI to convert the base URI at the given depth to the current base URI
      Throws:
        `URI.MalformedURIException`

    - #### processXMLBaseAttributes

          protected void processXMLBaseAttributes(org.apache.xerces.xni.XMLAttributes attributes)

      Search for a xml:base attribute, and if one is found, put the new base URI into effect.

    - #### processXMLLangAttributes

          protected void processXMLLangAttributes(org.apache.xerces.xni.XMLAttributes attributes)

      Search for a xml:lang attribute, and if one is found, put the new [language] into effect.

Copyright © 1999-2010 The Apache Software Foundation. All Rights Reserved.